# keys, values
KUBERNETES_METADATA_KEY = "metadata"
KUBERNETES_NAME_KEY = "name"
KUBERNETES_NAMESPACE_KEY = "namespace"
KUBERNETES_SPEC_KEY = "spec"
KUBERNETES_EXTERNALNAME_KEY = "externalName"
KUBERNETES_SELECTOR_KEY = "selector"
KUBERNETES_APP_KEY = "app"
KUBERNETES_PORTS_KEY = "ports"
KUBERNETES_PORT_KEY = "port"
KUBERNETES_TARGETPORT_KEY = "targetPort"
KUBERNETES_PROTOCOL_KEY = "protocol"
KUBERNETES_CAPACITY_KEY = "capacity"
KUBERNETES_STORAGE_KEY = "storage"
KUBERNETES_LABELS_KEY = "labels"
KUBERNETES_VOLUMENAME_KEY = "volumeName"
KUBERNETES_RESOURCES_KEY = "resources"
KUBERNETES_REQUESTS_KEY = "requests"
KUBERNETES_DATA_KEY = "data"
KUBERNETES_MATCHLABELS_KEY = "matchLabels"
KUBERNETES_ANNOTATIONS_KEY = "annotations"
KUBERNETES_RULES_KEY = "rules"
KUBERNETES_PATH_KEY = "path"
KUBERNETES_AFFINITY_KEY = "affinity"
KUBERNETES_NODE_AFFINITY_KEY = "nodeAffinity"
KUBERNETES_NODE_SELECTOR_TERMS_KEY = "nodeSelectorTerms"
KUBERNETES_MATCH_EXPRESSIONS_KEY = "matchExpressions"
KUBERNETES_KEY_KEY = "key"
KUBERNETES_OPERATOR_KEY = "operator"
KUBERNETES_VALUES_KEY = "values"
KUBERNETES_REQUIRED_KEY = "required"
KUBERNETES_REQUIRED_DURING_SCHEDULING_IGNORED_DURING_EXECUTION_KEY = "requiredDuringSchedulingIgnoredDuringExecution"
KUBERNETES_WEIGHT_KEY = "weight"
KUBERNETES_PREFERENCE_KEY = "preference"
KUBERNETES_PRIVILEGED_KEY = "privileged"
KUBERNETES_ITEMS_KEY = "items"
KUBERNETES_SUBPATH_KEY = "subPath"

KUBERNETES_LABEL_HOSTNAME_VALUE = "kubernetes.io/hostname"
KUBERNETES_LABEL_NODE_ROLE_MASTER_VALUE = "node-role.kubernetes.io/master"
KUBERNETES_OPERATOR_IN_VALUE = "In"
KUBERNETES_OPERATOR_DOES_NOT_EXIST_VALUE = "DoesNotExist"

KUBERNETES_API_VERSION_KEY = "apiVersion"
KUBERNETES_API_VERSION_V1_VALUE = "v1"
KUBERNETES_API_VERSION_DEFAULT_VALUE = KUBERNETES_API_VERSION_V1_VALUE
KUBERNETES_API_VERSION_RBAC_AUTHORIZATION_VALUE = "rbac.authorization.k8s.io"
KUBERNETES_API_VERSION_RBAC_AUTHORIZATION_DEFAULT_VALUE = f"{KUBERNETES_API_VERSION_RBAC_AUTHORIZATION_VALUE}/{KUBERNETES_API_VERSION_V1_VALUE}"
KUBERNETES_API_VERSION_NAMESPACE_DEFAULT_VALUE = "apps/v1"
KUBERNETES_API_VERSION_INGRESS_CONFIG_DEFAULT_VALUE = "networking.k8s.io/v1"

KUBERNETES_KIND_KEY = "kind"
KUBERNETES_KIND_VALUE_NAMESPACE = "Namespace"
KUBERNETES_KIND_VALUE_SERVICE = "Service"
KUBERNETES_KIND_VALUE_CONFIG_MAP = "ConfigMap"
KUBERNETES_KIND_VALUE_DEPLOYMENT = "Deployment"
KUBERNETES_KIND_VALUE_PERSISTENTVOLUME = "PersistentVolume"
KUBERNETES_KIND_VALUE_PERSISTENTVOLUMECLAIM = "PersistentVolumeClaim"
KUBERNETES_KIND_VALUE_SERVICEACCOUNT = "ServiceAccount"
KUBERNETES_KIND_VALUE_ROLE = "Role"
KUBERNETES_KIND_VALUE_CLUSTERROLE = "ClusterRole"
KUBERNETES_KIND_VALUE_ROLEBINDING = "RoleBinding"
KUBERNETES_KIND_VALUE_CLUSTERROLEBINDING = "ClusterRoleBinding"
KUBERNETES_KIND_VALUE_INGRESS = "Ingress"
KUBERNETES_KIND_VALUE_ENDPOINTS = "Endpoints"

KUBERNETES_TYPE_KEY = "type"
KUBERNETES_SERVICE_TYPE_VALUE_EXTERNAL_NAME = "ExternalName"
KUBERNETES_SERVICE_TYPE_VALUE_CLUSTER_IP = "ClusterIP"
KUBERNETES_SERVICE_TYPE_VALUE_NODE_PORT = "NodePort"
KUBERNETES_SERVICE_TYPE_VALUE_LOADBALANCER = "LoadBalancer"
KUBERNETES_SERVICE_SPEC_CLUSTERIP_KEY = "clusterIP"
KUBERNETES_SERVICE_SPEC_CLUSTERIP_NONE_VALUE = "None"

KUBERNETES_PROTOCOL_KEY = "protocol"
KUBERNETES_PROTOCOL_VALUE_TCP = "TCP"
KUBERNETES_PROTOCOL_VALUE_UDP = "UDP"

KUBERNETES_STORAGECLASSNAME_KEY = "storageClassName"
KUBERNETES_STORAGECLASSNAME_DEFAULT_VALUE = "manual"

KUBERNETES_ACCESSMODES_KEY = "accessModes"
KUBERNETES_ACCESSMODES_VALUE_READ_WRITE_MANY = "ReadWriteMany"
KUBERNETES_ACCESSMODES_VALUE_READ_ONLY = "ReadOnly"

KUBERNETES_PERSISTENT_VOLUME_RECLAIM_POLICY_KEY = "persistentVolumeReclaimPolicy"
KUBERNETES_PERSISTENT_VOLUME_RECLAIM_POLICY_VALUE_RETAIN = "Retain"
KUBERNETES_PERSISTENT_VOLUME_RECLAIM_POLICY_VALUE_DELETE = "Delete"

KUBERNETES_NFS_KEY = "nfs"
KUBERNETES_NFS_SERVER_KEY = "server"
KUBERNETES_HOSTPATH_KEY = "hostPath"

KUBERNETES_NFS_MOUNT_OPTIONS_KEY = "mountOptions"
KUBERNETES_NFS_MOUNT_OPTIONS_DEFAULT_VALUE = ["nfsvers=4.1", "hard"]

KUBERNETES_DEPLOYMENT_REPLICAS_KEY = "replicas"
KUBERNETES_DEPLOYMENT_REPLICAS_DEFAULT_VALUE = 1
KUBERNETES_DEPLOYMENT_TEMPLATE_KEY = "template"
KUBERNETES_DEPLOYMENT_CONTAINERS_KEY = "containers"
KUBERNETES_DEPLOYMENT_IMAGE_KEY = "image"
KUBERNETES_DEPLOYMENT_IMAGEPULLPOLICY_KEY = "imagePullPolicy"
KUBERNETES_DEPLOYMENT_IMAGEPULLPOLICY_IFNOTPRESENT_VALUE = "IfNotPresent"
KUBERNETES_DEPLOYMENT_IMAGEPULLPOLICY_ALWAYS_VALUE = "Always"
KUBERNETES_DEPLOYMENT_IMAGEPULLPOLICY_DEFAULT_VALUE = KUBERNETES_DEPLOYMENT_IMAGEPULLPOLICY_ALWAYS_VALUE
KUBERNETES_DEPLOYMENT_VOLUMEMOUNTS_KEY = "volumeMounts"
KUBERNETES_DEPLOYMENT_MOUNTPATH_KEY = "mountPath"
KUBERNETES_DEPLOYMENT_VOLUMES_KEY = "volumes"
KUBERNETES_DEPLOYMENT_CONFIG_MAP_KEY = "configMap"
KUBERNETES_DEPLOYMENT_PERSISTENTVOLUMECLAIM_KEY = "persistentVolumeClaim"
KUBERNETES_DEPLOYMENT_CLAIMNAME_KEY = "claimName"
KUBERNETES_DEPLOYMENT_CONTAINERPORT_KEY = "containerPort"
KUBERNETES_DEPLOYMENT_SERVICEACCOUNTNAME_KEY = "serviceAccountName"
KUBERNETES_DEPLOYMENT_ENVFROM_KEY = "envFrom"
KUBERNETES_DEPLOYMENT_CONFIGMAPREF_KEY = "configMapRef"
KUBERNETES_DEPLOYMENT_SECURITYCONTEXT_KEY = "securityContext"
KUBERNETES_DEPLOYMENT_IMAGE_PULL_SECRETS_KEY = "imagePullSecrets"

KUBERNETES_SERVICEACCOUNT_RULES_KEY = KUBERNETES_RULES_KEY
KUBERNETES_SERVICEACCOUNT_APIGROUPS_KEY = "apiGroups"
KUBERNETES_SERVICEACCOUNT_VERBS_KEY = "verbs"
KUBERNETES_SERVICEACCOUNT_ROLEREF_KEY = "roleRef"
KUBERNETES_SERVICEACCOUNT_SUBJECTS_KEY = "subjects"
KUBERNETES_SERVICEACCOUNT_APIGROUP_KEY = "apiGroup"

KUBERNETES_ENDPOINTS_SUBSETS_KEY = "subsets"
KUBERNETES_ENDPOINTS_ADDRESSES_KEY = "addresses"
KUBERNETES_ENDPOINTS_IP_KEY = "ip"

KUBERNETES_INGRESS_HOSTS_KEY = "hosts"
KUBERNETES_INGRESS_TLS_KEY = "tls"
KUBERNETES_INGRESS_SECRETNAME_KEY = "secretName"
KUBERNETES_INGRESS_HOST_KEY = "host"
KUBERNETES_INGRESS_HTTP_KEY = "http"
KUBERNETES_INGRESS_PATHS_KEY = "paths"
KUBERNETES_INGRESS_PATHTYPE_KEY = "pathType"
KUBERNETES_INGRESS_BACKEND_KEY = "backend"
KUBERNETES_INGRESS_SERVICE_KEY = "service"
KUBERNETES_INGRESS_SERVICEPORTNUMBER_KEY = "number"
KUBERNETES_INGRESS_RULES_KEY = KUBERNETES_RULES_KEY
KUBERNETES_INGRESS_USE_PROXY_PROTOCOL_KEY = "use-proxy-protocol"


# some default values
KUBERNETES_NAMESPACE_DEFAULT = "default"
KUBERNETES_PRIVILEGED_DEFAULT_VALUE = False
KUBERNETES_WEIGHT_DEFAULT_VALUE = 1
KUBERNETES_INGRESS_PATH_DEFAULT_VALUE = "/"
KUBERNETES_INGRESS_PATHTYPE_DEFAULT_VALUE = "Prefix"
KUBERNETES_INGRESS_USE_PROXY_PROTOCOL_DEFAULT_VALUE = "false"
